apiVersion: k8s.mariadb.com/v1alpha1
kind: MariaDB
metadata:
  name: {{ k8s_mariadbop_name }}
  namespace: {{ k8s_mariadbop_namespace }}
spec:
  serviceAccountName: "{{ k8s_mariadbop_service_account }}"

  username: mariadb
  database: mariadb

  image: mariadb:10.11.7
  imagePullPolicy: IfNotPresent

  port: 3306

  affinity:
    enableAntiAffinity: {{ k8s_mariadbop_antiaffinity }}

  replicas: {{ k8s_mariadbop_instances }}

  replication:
    enabled: true

  storage:
    size: {{ k8s_mariadbop_storagesize }}
    storageClassName: {{ k8s_mariadbop_storageclassname }}
    resizeInUseVolumes: true
    waitForVolumeResize: true
  volumes:
    - name: "{{ k8s_mariadbop_name }}-backup"
      persistentVolumeClaim:
        claimName: "{{ k8s_mariadbop_name }}-backup"
{% if k8s_mariadbop_vault_server != "" %}
    - name: secrets-store-inline
      csi:
        driver: secrets-store.csi.k8s.io
        readOnly: true
        volumeAttributes:
          secretProviderClass: "{{ k8s_mariadbop_name }}vaulty"
{% endif %}
  volumeMounts:
    - name: "{{ k8s_mariadbop_name }}-backup"
      mountPath: /var/mariadb/backup/
{% if k8s_mariadbop_vault_server != "" %}
    - name: secrets-store-inline
      mountPath: "/mnt/secrets-store"
      readOnly: true
{% endif %}

  connection:
    secretName: "connection-{{ k8s_mariadbop_name }}"
    secretTemplate:
      key: dsn
    healthCheck:
      interval: 10s
      retryInterval: 3s
    params:
      parseTime: "true"

  myCnf: |
    [mariadb]
    bind-address=*
    default_storage_engine=InnoDB
    binlog_format=row
    innodb_autoinc_lock_mode=2
    max_allowed_packet=256M

  resources:
    requests:
      cpu: 100m
      memory: 128Mi
    limits:
      memory: 1Gi

  env:
    - name: TZ
      value: "{{ k8s_mariadbop_tz }}"
{%  if k8s_mariadbop_vault_server != "" %}
    - name: MARIADB_ROOT_PASSWORD
      valueFrom:
        secretKeyRef:
          key: rootpassword
          name: dbpass
    - name: MARIADB_PASSWORD
      valueFrom:
        secretKeyRef:
          key: password
          name: dbpass
{% endif %}
  envFrom:
    - configMapRef:
        name: {{ k8s_mariadbop_name }}

  podSecurityContext:
    runAsUser: 0

  securityContext:
    allowPrivilegeEscalation: false

  livenessProbe:
    exec:
      command:
        - bash
        - -c
        - mariadb -u root -p"${MARIADB_ROOT_PASSWORD}" -e "SELECT 1;"
    initialDelaySeconds: 20
    periodSeconds: 10
    timeoutSeconds: 5

  readinessProbe:
    exec:
      command:
        - bash
        - -c
        - mariadb -u root -p"${MARIADB_ROOT_PASSWORD}" -e "SELECT 1;"
    initialDelaySeconds: 20
    periodSeconds: 10
    timeoutSeconds: 5

  podDisruptionBudget:
    maxUnavailable: 50%

  updateStrategy:
    type: RollingUpdate

  primaryService:
    type: LoadBalancer
{% if k8s_mariadbop_db_lb_ip != "" %}
    metadata:
      annotations:
        metallb.universe.tf/loadBalancerIPs: "{{ k8s_mariadbop_db_lb_ip }}"
{% endif %}

  secondaryService:
    type: LoadBalancer

  metrics:
    enable: "{{ k8s_mariadbop_metrics }}"
